﻿namespace HeuristicLab.Algorithms.PushGP.Data.Random {
  using System;
  using System.Collections.Generic;
  using System.Threading;

  using HeuristicLab.Core;
  using HeuristicLab.Random;

  public class RandomFactory {
    public static readonly RandomFactory Instance = new RandomFactory();

    private static int seed;
    private static IList<IRandom> randoms = new List<IRandom>();

    static RandomFactory() {
      Seed = Environment.TickCount;
    }

    public static int Seed
    {
      get { return seed; }
      set
      {
        seed = value;

        for (var i = 0; i < randoms.Count; i++) {
          randoms[i].Reset(seed);
        }
      }
    }

    public static ThreadLocal<IRandom> GetRandom() {
      /*Interlocked.Increment(ref Seed)*/
      return new ThreadLocal<IRandom>(() => new FastRandom(Seed));
    }
  }
}
